#ifndef _FILESTRUCTURETREE_H
#define _FILESTRUCTURETREE_H

#include <wx/wx.h>
#include <wx/treectrl.h>
#include "libnw/are.h"

#include "config.h"

#include "MODFile.h"
#include "ITPResource.h"

class TreeItemData : public wxTreeItemData {
 protected:
    NWNDataType item;
 public:
    TreeItemData(NWNDataType& nwndt) : item(nwndt) {}
    NWNDataType getItem() {return item;}
};

/**
 * Sample NWN File Viewer using libnw
 */
class FileStructureTree : public wxTreeCtrl {
 public:
        FileStructureTree(wxWindow *parent, const wxWindowID id=-1,
			  const wxPoint& pos=wxPoint(-1,-1), 
			  const wxSize& size=wxSize(-1,-1),
			  long style= (wxTR_HIDE_ROOT | wxTR_TWIST_BUTTONS));	
	void treeFromMODFile(MODFile& mod);
 protected:
	void appendListItem(const wxTreeItemId& parent,
			    NWNDataType& item,
			    NWNDataType& parentItem);
	wxTreeItemId appendListItems(const wxTreeItemId& parent,
                                     const ITPResource& gic,
                                     std::string listLabel,
                                     std::string itemName);
	void appendListItems(const wxTreeItemId& parent,
			     const ITPResource& gic,
			     std::string itemName);
};

#endif


