#ifndef _FILEVIEWER_H
#define _FILEVIEWER_H

#include <wx/wx.h>
#include <wx/splitter.h>
#include <wx/listctrl.h>

#include "libnw/gamedir.h"
#include "libnw/global.h"

#include "FileStructureTree.h"

#include "config.h"

/**
 * Sample NWN File Viewer using libnw
 */
class FileViewerApp : public wxApp {
 public:
    virtual bool OnInit();
};

class FileViewer : public wxFrame {
 protected:
    FileStructureTree *tree;
    wxSplitterWindow *splitter;
    wxListCtrl *listCtrl;
    MODFile mod;

    void clearList();
    void clearTree();
    void addListItem(std::string name, std::string value);
 public:
    FileViewer(const wxString& title, int x, int y, int w, int h);
    virtual ~FileViewer();

    void OnOpen(wxCommandEvent& WXUNUSED(event));
    void OnAbout(wxCommandEvent& WXUNUSED(event));
    void OnTreeSelect(wxTreeEvent& event);
 private:
    DECLARE_EVENT_TABLE()
};

///menu item and control ids
enum {
    FileViewer_Open = 1,
    FileViewer_About = wxID_ABOUT,
    FileStructureTree_Ctrl = wxID_HIGHEST + 1
};

DECLARE_APP(FileViewerApp)

#endif


